 unit funkc;
interface
const	radian:extended=180.0/pi;
function sn(d:extended):extended;
function cs(d:extended):extended;
function tn(d:extended):extended;
function atn(d:extended):extended;
function asn(d:extended):extended;
function anm(mean,exc:extended):extended;
function polowka(abx,mbx:extended):extended;
function dekl(l,b,e:extended):extended;
function rekt(l,b,e:extended):extended;
function opoz(d:extended):extended;
function normal(d:extended):extended;
function mod360(d:extended):extended;
implementation
const	kolo=360.0;
	pkolo=180.0;
function sn;
begin
 sn:=sin(d/radian);
end;
function cs;
begin
 cs:=cos(d/radian);
end;
function tn;
begin
 tn:=sn(d)/cs(d);
end;
function atn;
begin
 atn:=arctan(d)*radian;
end;
function asn;
var	yz1:extended;
begin
 yz1:=d/sqrt(1-sqr(d));
 asn:=atn(yz1);
end;
function anm;
var	y1:extended;
begin
 y1:=mean;
 repeat
  y1:=mean+sn(y1)*exc*radian;
 until abs(mean-y1+sn(y1)*exc*radian)<1e-7;
 y1:=sqrt((1+exc)/(1-exc))*tn(y1/2);
 anm:=2*atn(y1);
end;
function polowka;
var	yz1:extended;
begin
 yz1:=abx-kolo;
 repeat  yz1:=yz1+pkolo  until  yz1>mbx;
 if yz1>kolo then polowka:=yz1-kolo else polowka:=yz1;
end;
function dekl;
var	ddd:extended;
begin
 ddd:=sn(b)*cs(e)+sn(e)*cs(b)*sn(l);
 dekl:=asn(ddd);
end;
function rekt;
var	y1:extended;
begin
 y1:=tn(l)*cs(e)-sn(e)*tn(b)/cs(l);
 y1:=atn(y1);
 rekt:=normal(pkolo*round(l/pkolo)+y1);
end;
function opoz;
begin
 opoz:=normal(d+pkolo);
end;
function normal;
var	y1:extended;
begin
 y1:=mod360(d);
 if y1<0 then normal:=y1+kolo   else   normal:=y1;
end;
function mod360(d:extended):extended;
var	y1:extended;
begin
 y1:=d/kolo;
 mod360:=kolo*(y1-round(y1));
end;
end.
