 unit nut1;
interface
type	ext4=array[1..4] of extended;
	ext6=array[1..6] of extended;
procedure elemks(t:extended; var elk:ext6);
procedure wielnut(t,h1,lgg:extended; var wiel:ext4);
implementation
uses	funkc;
type	wielkosc=1..6;
	nutrec=record wsp:array[1..5] of shortint; p:single; dp:integer;
		e:single; de:shortint; end;
	mac1=array[1..106] of nutrec;
	mac3=array[1..6,1..4] of double;
procedure elemks;
const	ma3:mac3=
		((1009677.85 , 129602771.27 ,  1.089, 0    ),
		 ( 785939.157,1732564372.598, -5.802, 0.019),
		 (1018578.046,      6190.046,  1.666, 0.012),
		 ( 300072.424,  14648449.965,-37.112,-0.045),
		 ( 450160.28 ,  -6962890.539,  7.455, 0.008),
		 (  84381.448,       -46.815,-0.00059,0.01813));
var	i:word; fpom:extended;
begin
 for i:=1 to 6 do
 begin
  fpom:=ma3[i,1] + t*(ma3[i,2] + t*(ma3[i,3] + t*ma3[i,4]));
  elk[i]:=frac(fpom/1296000)*360;
 end;
end;
procedure wielnut;
const	ma1:mac1=
	((wsp:( 0, 0, 0, 0, 1); p:-171996; dp:-1742; e:92025; de: 89),
	 (wsp:( 0, 0, 0, 0, 2); p:   2062; dp:    2; e: -895; de:  5),
	 (wsp:(-2, 0, 2, 0, 1); p:     46; dp:    0; e:  -24; de:  0),
	 (wsp:( 2, 0,-2, 0, 0); p:     11; dp:    0; e:    0; de:  0),
	 (wsp:(-2, 0, 2, 0, 2); p:     -3; dp:    0; e:    1; de:  0),
	 (wsp:( 1,-1, 0,-1, 0); p:     -3; dp:    0; e:    0; de:  0),
	 (wsp:( 0,-2, 2,-2, 1); p:     -2; dp:    0; e:    1; de:  0),
	 (wsp:( 2, 0,-2, 0, 1); p:      1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 0, 2,-2, 2); p: -13187; dp:  -16; e: 5736; de:-31),
	 (wsp:( 0, 1, 0, 0, 0); p:   1426; dp:  -34; e:   54; de: -1),
	 (wsp:( 0, 1, 2,-2, 2); p:   -517; dp:   12; e:  224; de: -6),
	 (wsp:( 0,-1, 2,-2, 2); p:    217; dp:   -5; e:  -95; de:  3),
	 (wsp:( 0, 0, 2,-2, 1); p:    129; dp:    1; e:  -70; de:  0),
	 (wsp:( 2, 0, 0,-2, 0); p:     48; dp:    0; e:    1; de:  0),
	 (wsp:( 0, 0, 2,-2, 0); p:    -22; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 2, 0, 0, 0); p:     17; dp:   -1; e:    0; de:  0),
	 (wsp:( 0, 1, 0, 0, 1); p:    -15; dp:    0; e:    9; de:  0),
	 (wsp:( 0, 2, 2,-2, 2); p:    -16; dp:    1; e:    7; de:  0),
	 (wsp:( 0,-1, 0, 0, 1); p:    -12; dp:    0; e:    6; de:  0),
	 (wsp:(-2, 0, 0, 2, 1); p:     -6; dp:    0; e:    3; de:  0),
	 (wsp:( 0,-1, 2,-2, 1); p:     -5; dp:    0; e:    3; de:  0),
	 (wsp:( 2, 0, 0,-2, 1); p:      4; dp:    0; e:   -2; de:  0),
	 (wsp:( 0, 1, 2,-2, 1); p:      4; dp:    0; e:   -2; de:  0),
	 (wsp:( 1, 0, 0,-1, 0); p:     -4; dp:    0; e:    0; de:  0),
	 (wsp:( 2, 1, 0,-2, 0); p:      1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 0,-2, 2, 1); p:      1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 1,-2, 2, 0); p:     -1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 1, 0, 0, 2); p:      1; dp:    0; e:    0; de:  0),
	 (wsp:(-1, 0, 0, 1, 1); p:      1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 1, 2,-2, 0); p:     -1; dp:    0; e:    0; de:  0),
	 (wsp:( 0, 0, 2, 0, 2); p:-2274; dp: -2; e:977; de:-5),
	 (wsp:( 1, 0, 0, 0, 0); p:  712; dp:  1; e: -7; de: 0),
	 (wsp:( 0, 0, 2, 0, 1); p: -386; dp: -4; e:200; de: 0),
	 (wsp:( 1, 0, 2, 0, 2); p: -301; dp:  0; e:129; de:-1),
	 (wsp:( 1, 0, 0,-2, 0); p: -158; dp:  0; e: -1; de: 0),
	 (wsp:(-1, 0, 2, 0, 2); p:  123; dp:  0; e:-53; de: 0),
	 (wsp:( 0, 0, 0, 2, 0); p:   63; dp:  0; e: -2; de: 0),
	 (wsp:( 1, 0, 0, 0, 1); p:   63; dp:  1; e:-33; de: 0),
	 (wsp:(-1, 0, 0, 0, 1); p:  -58; dp: -1; e: 32; de: 0),
	 (wsp:(-1, 0, 2, 2, 2); p:  -59; dp:  0; e: 26; de: 0),
	 (wsp:( 1, 0, 2, 0, 1); p:  -51; dp:  0; e: 27; de: 0),
	 (wsp:( 0, 0, 2, 2, 2); p:  -38; dp:  0; e: 16; de: 0),
	 (wsp:( 2, 0, 0, 0, 0); p:   29; dp:  0; e: -1; de: 0),
	 (wsp:( 1, 0, 2,-2, 2); p:   29; dp:  0; e:-12; de: 0),
	 (wsp:( 2, 0, 2, 0, 2); p:  -31; dp:  0; e: 13; de: 0),
	 (wsp:( 0, 0, 2, 0, 0); p:   26; dp:  0; e: -1; de: 0),
	 (wsp:(-1, 0, 2, 0, 1); p:   21; dp:  0; e:-10; de: 0),
	 (wsp:(-1, 0, 0, 2, 1); p:   16; dp:  0; e: -8; de: 0),
	 (wsp:( 1, 0, 0,-2, 1); p:  -13; dp:  0; e:  7; de: 0),
	 (wsp:(-1, 0, 2, 2, 1); p:  -10; dp:  0; e:  5; de: 0),
	 (wsp:( 1, 1, 0,-2, 0); p:   -7; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 1, 2, 0, 2); p:    7; dp:  0; e: -3; de: 0),
	 (wsp:( 0,-1, 2, 0, 2); p:   -7; dp:  0; e:  3; de: 0),
	 (wsp:( 1, 0, 2, 2, 2); p:   -8; dp:  0; e:  3; de: 0),
	 (wsp:( 1, 0, 0, 2, 0); p:    6; dp:  0; e:  0; de: 0),
	 (wsp:( 2, 0, 2,-2, 2); p:    6; dp:  0; e: -3; de: 0),
	 (wsp:( 0, 0, 0, 2, 1); p:   -6; dp:  0; e:  3; de: 0),
	 (wsp:( 0, 0, 2, 2, 1); p:   -7; dp:  0; e:  3; de: 0),
	 (wsp:( 1, 0, 2,-2, 1); p:    6; dp:  0; e: -3; de: 0),
	 (wsp:( 0, 0, 0,-2, 1); p:   -5; dp:  0; e:  3; de: 0),
	 (wsp:( 1,-1, 0, 0, 0); p:    5; dp:  0; e:  0; de: 0),
	 (wsp:( 2, 0, 2, 0, 1); p:   -5; dp:  0; e:  3; de: 0),
	 (wsp:( 0, 1, 0,-2, 0); p:   -4; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0,-2, 0, 0); p:    4; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0, 0, 1, 0); p:   -4; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 1, 0, 0, 0); p:   -3; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0, 2, 0, 0); p:    3; dp:  0; e:  0; de: 0),
	 (wsp:( 1,-1, 2, 0, 2); p:   -3; dp:  0; e:  1; de: 0),
	 (wsp:(-1,-1, 2, 2, 2); p:   -3; dp:  0; e:  1; de: 0),
	 (wsp:(-2, 0, 0, 0, 1); p:   -2; dp:  0; e:  1; de: 0),
	 (wsp:( 3, 0, 2, 0, 2); p:   -3; dp:  0; e:  1; de: 0),
	 (wsp:( 0,-1, 2, 2, 2); p:   -3; dp:  0; e:  1; de: 0),
	 (wsp:( 1, 1, 2, 0, 2); p:    2; dp:  0; e: -1; de: 0),
	 (wsp:(-1, 0, 2,-2, 1); p:   -2; dp:  0; e:  1; de: 0),
	 (wsp:( 2, 0, 0, 0, 1); p:    2; dp:  0; e: -1; de: 0),
	 (wsp:( 1, 0, 0, 0, 2); p:   -2; dp:  0; e:  1; de: 0),
	 (wsp:( 3, 0, 0, 0, 0); p:    2; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0, 2, 1, 2); p:    2; dp:  0; e: -1; de: 0),
	 (wsp:(-1, 0, 0, 0, 2); p:    1; dp:  0; e: -1; de: 0),
	 (wsp:( 1, 0, 0,-4, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:(-2, 0, 2, 2, 2); p:    1; dp:  0; e: -1; de: 0),
	 (wsp:(-1, 0, 2, 4, 2); p:   -2; dp:  0; e:  1; de: 0),
	 (wsp:( 2, 0, 0,-4, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 1, 2,-2, 2); p:    1; dp:  0; e: -1; de: 0),
	 (wsp:( 1, 0, 2, 2, 1); p:   -1; dp:  0; e:  1; de: 0),
	 (wsp:(-2, 0, 2, 4, 2); p:   -1; dp:  0; e:  1; de: 0),
	 (wsp:(-1, 0, 4, 0, 2); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 1,-1, 0,-2, 0); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 2, 0, 2,-2, 1); p:    1; dp:  0; e: -1; de: 0),
	 (wsp:( 2, 0, 2, 2, 2); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0, 0, 2, 1); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0, 4,-2, 2); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 3, 0, 2,-2, 2); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0, 2,-2, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 1, 2, 0, 1); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:(-1,-1, 0, 2, 1); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0,-2, 0, 1); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0, 2,-1, 2); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 1, 0, 2, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0,-2,-2, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0,-1, 2, 0, 1); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 1, 0,-2, 1); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 1, 0,-2, 2, 0); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 2, 0, 0, 2, 0); p:    1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 0, 2, 4, 2); p:   -1; dp:  0; e:  0; de: 0),
	 (wsp:( 0, 1, 0, 1, 0); p:    1; dp:  0; e:  0; de: 0));
var	xx:extended; i,j:word; elk:ext6; ll:array[1..5] of extended;
begin
 elemks(t,elk);
 ll[1]:=elk[2]-elk[4];
 ll[2]:=elk[1]-elk[3];
 ll[3]:=elk[2]-elk[5];
 ll[4]:=elk[2]-elk[1];
 ll[5]:=elk[5];
 wiel[1]:=0;
 wiel[2]:=0;
 for i:=1 to 106 do
 begin
  xx:=0;
  for j:=1 to 5 do   xx:=xx+ll[j]*ma1[i].wsp[j];
  wiel[2]:=wiel[2]+cs(xx)*(ma1[i].e+t*ma1[i].de/10);
  wiel[1]:=wiel[1]+sn(xx)*(ma1[i].p+t*ma1[i].dp/10);
 end;
 wiel[1]:=wiel[1]/10000;
 wiel[2]:=wiel[2]/10000;
 wiel[3]:=elk[6]+wiel[2]/3600;
 wiel[4]:=24110.54841+t*(8640184.812866+t*(0.093104-t*6.2e-6)) +
  (h1+lgg)*3600 + wiel[1]*cs(wiel[3])/15;
 wiel[4]:=normal(wiel[4]/240);
end;
end.
