unit	wekt;
interface
type	wektor=array[1..3] of extended;

procedure dodwekt(a,b:wektor; var c:wektor);
procedure mnozwekt(a:wektor; b:extended; var c:wektor);
function ilsk(a,b:wektor):extended;
procedure sfe2rec(a:wektor; var b:wektor);
procedure rec2sfe(a:wektor; var b:wektor);
procedure ekl2row(a:wektor; e:extended; var b:wektor);
procedure e2r(a:wektor; e:extended; var b:wektor);
procedure rsfe2rec(a:wektor; var b:wektor);

implementation
uses	funkc;

procedure dodwekt(a,b:wektor; var c:wektor);
var	k:word;
begin
 for k:=1 to 3 do c[k]:=a[k]+b[k];
end;

procedure mnozwekt(a:wektor; b:extended; var c:wektor);
var	k:word;
begin
 for k:=1 to 3 do c[k]:=a[k]*b;
end;

function ilsk(a,b:wektor):extended;
var	k:word; tmp:extended;
begin
 tmp:=0;
 for k:=1 to 3 do tmp:=tmp+a[k]*b[k];
 ilsk:=tmp;
end;

procedure sfe2rec(a:wektor; var b:wektor);
{(deg)l,b,r=>x,y,z}
var	tmp:extended;
begin
 tmp:=a[3]*cs(a[2]);
 b[1]:=tmp*cs(a[1]);
 b[2]:=tmp*sn(a[1]);
 b[3]:=a[3]*sn(a[2]);
end;

procedure rsfe2rec(a:wektor; var b:wektor);
{(rad)l,b,r=>x,y,z}
var	tmp:extended;
begin
 tmp:=a[3]*cos(a[2]);
 b[1]:=tmp*cos(a[1]);
 b[2]:=tmp*sin(a[1]);
 b[3]:=a[3]*sin(a[2]);
end;

procedure rec2sfe(a:wektor; var b:wektor);
{x,y,z=>l,b,r(deg)}
var	k:word; tmp,r:extended;
begin
 r:=0;
 for k:=1 to 3 do r:=r+sqr(a[k]);
 r:=sqrt(r);
 tmp:=atn(a[2]/a[1]);
 if a[1]<0 then tmp:=opoz(tmp);
 b[1]:=normal(tmp);
 b[2]:=asn(a[3]/r);
 b[3]:=r;
end;

procedure ekl2row(a:wektor; e:extended; var b:wektor);
var	sne, cse : extended;
begin
 sne:=sn(e);
 cse:=cs(e);
 b[1]:=a[1];
 b[2]:=a[2]*cse-a[3]*sne;
 b[3]:=a[3]*cse+a[2]*sne;
end;

procedure e2r(a:wektor; e:extended; var b:wektor);
var	aa, bb : wektor;
begin
 sfe2rec(a,aa);
 ekl2row(aa,e,bb);
 rec2sfe(bb,b);
end;

end.
