unit	ziemia;
interface
uses	wekt;
procedure oblpl(t:extended; var pla:wektor);
procedure loadmac;
implementation
uses	funkc,aspekty,plan;
type	wd18=array[1..18] of word;
	plrec=array[1..3] of double;
	macpl=array[1..2425] of plrec;
const	dlug:wd18=
 ( 559, 341, 142,  22,  11,   5, 184,  99,  49,  11,   5,   0, 526, 292, 139,  27,  10,   3);
var	mac:^macpl;

procedure loadmac;
var	f:file of macpl;
begin
 assign(f,'ziemia.dat');
 reset(f);
 new(mac);
 read(f,mac^);
 close(f);
end;

function mod2pi(x:extended):extended;
var	dpi,tmp:extended;
begin
 dpi:=2*pi;
 tmp:=x/dpi;
 mod2pi:=dpi*(tmp-round(tmp));
end;

procedure hel2geo(pl0:wektor; var plk:wektor);
var	ww,ww1:wektor;
begin
 rsfe2rec(pl0,ww);
 mnozwekt(ww,-1,ww1);
 dodwekt(ww1,pziem,ww);
 rec2sfe(ww,plk);
{ plk[1]:=norm(pl0[1]*radian+180);
 plk[2]:=-pl0[2]*radian;
 plk[3]:=pl0[3];}
end;

procedure oblpl(t:extended; var pla:wektor);
var	l,m,n,n1,nr,cnt:word; el:array[1..8] of extended;
	u,u1,tmp,r0,r1,f0,f1:extended; dane:plrec; pl0,pl1,plk,pln:wektor;
begin
 u:=t/10;
 u1:=u+1e-12;
 cnt:=0;
 for l:=1 to 3 do
 begin
  pl0[l]:=0;
  pl1[l]:=0;
  f0:=1;
  f1:=1;
  for m:=1 to 6 do
  begin
   nr:=dlug[(l-1)*6+m];
   r0:=0;
   r1:=0;
   if nr<>0 then for n:=1 to nr do
   begin
    inc(cnt);
    dane:=mac^[cnt];
    r0:=r0+dane[1]*cos(mod2pi(dane[2]+u*dane[3]));
    r1:=r1+dane[1]*cos(mod2pi(dane[2]+u1*dane[3]));
   end;
   pl0[l]:=pl0[l]+r0*f0;
   pl1[l]:=pl1[l]+r1*f1;
   f0:=f0*u;
   f1:=f1*u1;
  end;
 end;
 tmp:=0.0935/206264.806;
 pl0[1]:=pl0[1]-tmp;
 pl1[1]:=pl1[1]-tmp;
 tmp:=(0.05582/206264.806)*sn(358540.2864*u+38.31243);
 pl0[2]:=pl0[2]-tmp;
 pl1[2]:=pl1[2]-tmp;
 hel2geo(pl0,plk);
 hel2geo(pl1,pln);
 for l:=1 to 2 do
 begin
  tmp:=pln[l]-plk[l];
  if ((l=1) and (tmp>180)) then tmp:=tmp-360;
  plk[l]:=plk[l]-tmp*plk[3]*1.581250734e4;
 { 149597870000/299792458/3155760000=1.581250734e-7}
 end;
 plk[1]:=norm(plk[1]);
 for l:=1 to 3 do pla[l]:=plk[l];
end;
end.
